### Clustering

Having determined the events in each pixel it is possible to reconstruct the image with reduced noise levels using the matrix \(E\). However, this will not tell us anything about the properties of actual release events (e.g., spark/wave numbers or properties) as these macroscopic events are made up of several events from different pixels. It is therefore necessary to combine elementary events from various pixels into macroscopic release events.

This is achieved using the clustering method DBSCAN \cite{Sander_1998}. The works in the parameter space and finds clusters of arbitrary shape based on the density of events. This is preferable to standard clustering methods which often yield radially symmetric clusters (k-means, etc). 

Clustering is performed in two steps. First, pixel events are distributed into groups accoring to their shape i.e., clustering is done on the matrix \(E^s\). This is possible because, although the function used for fitting various release events (e.g., sparks or waves) is the same, the shape parameters of a event approximating a spark are likely to be more similar to other spark events rather than wave events. This is clearly visible on Figure x where ...
. In the second clustering step, the \(E^p\) matrix is cluster for each shape group and physically nearby clusters of similar events are obtained. With this two-step approach, release events of various types consisting on elementary events from multiple pixels are obtained. 