### Region detection
Before it is possible to fit the fluorescence signal from each pixel with a transient function, candidate regions containing possible events must be detected. For this we have modified a continous wavelet transform based peak detection algorithm by Du et al.\cite{Du_2006}. Whereas the the original algorithm of Du et al. provides the location of the peak, we have extended it to also yield the the width of the peak.

The original algorith works by joining the wavelet transform values along local maxima for increasing window lengths. Ridge lines obatained in this manner are taken to correspond to peaks if they satisfy certain criteria (length of the ridge, SNR, etc.) In our extension, the width of the peak is obtained from finding the first maximum of the wavelet transform values along the ridge line. 

Region estimation is performed iteratively. This is done to ensure that regions containing overlapping events are correctly identified. At each pass regions which have no overlaps and regions which only overlap with regions having a lower peak SNR are fitted. After a successful fit, the result is subtracted from the original signal and region detection is performed again, followed by fitting. This process is continued until no more regions are detected or successfully fitted. 

